-- Lips.applescript
-- Lips

--  Created by Nico Rohrbach on 29.01.06.
--  Copyright 2003 - 2006 Superpixel. All rights reserved.


property theText : ""
property theVoice : "Vicki" -- default Voice is Vicki
property the_Speed : 185 -- normal speak speed (160 thru 210 are normal)
property thePath : ""
property OSVersion : ""
property FirstRunFlag : true


on will finish launching theObject
	registerSettings()
	readSettings()
end will finish launching

on launched theObject
	checkOSversion()
	if OSVersion < "10.3" then -- here we set the os version we need as minimum.
		beep
		display alert "Lips requires Mac OS X 10.3 Panther." as critical message "The currently installed version is: " & OSVersion & "." & 
			return & "Get Panther from www.apple.com/store" default button "Quit" --attached to window "main"
		quit me
		return
	end if
	
	if FirstRunFlag is true then
		center window "main"
		set FirstRunFlag to false
	end if
	
	if theVoice is not equal to "" then
		tell popup button "ChoosePerson" of window "main"
			set its current menu item to its first menu item whose id is (get id of first menu item whose title contains theVoice)
		end tell
	end if
	
	set contents of slider "speed" of window "main" to the_Speed as integer
	
	tell text view "theTextInput" of scroll view "theTextInput" of window "main"
		set theFont to call method "fontWithName:size:" of class "NSFont" with parameters {"Lucida Grande", 14}
		call method "setFont:" of object it with parameter theFont
	end tell
	
	set background color of window "main" to {51914, 51914, 51914}
	show window "main"
end launched


on clicked theObject
	if name of theObject is "listen" then
		set theText to contents of text view "theTextInput" of scroll view "theTextInput" of window "main" as text
		say "[[rate " & (the_Speed as text) & "]]" & theText using theVoice
		
	else if name of theObject is "save" then
		tell save panel
			set required file type to "aiff"
			set title to "Save As"
			set prompt to "Save"
			set treat packages as directories to false
		end tell
		display save panel in directory "~/Desktop" with file name "" attached to window of theObject
		
	else if name of theObject is "clear" then
		set contents of text view "theTextInput" of scroll view "theTextInput" of window "main" to ""
		
	end if
end clicked


on panel ended theObject with result withResult
	if withResult is 1 then
		set theText to contents of text view "theTextInput" of scroll view "theTextInput" of window "main" as text
		set thePath to POSIX file (path name of save panel)
		say "[[rate " & (the_Speed as text) & "]]" & theText using theVoice saving to thePath
	end if
end panel ended


on will quit theObject
	writeSettings()
end will quit


on choose menu item theObject
	if name of theObject is "menu_save" then
		tell save panel
			set title to "Save As"
			set prompt to "Save"
			set required file type to "aiff"
			set treat packages as directories to false
		end tell
		display save panel in directory "~/Desktop" with file name "" attached to window "main" -- of theObject
		
	else if name of theObject is "menu_listen" then
		set theText to contents of text view "theTextInput" of scroll view "theTextInput" of window "main" as text
		say "[[rate " & (the_Speed as text) & "]]" & theText using theVoice
		
	else if name of theObject is "ChoosePerson" then
		tell popup button "ChoosePerson" of window "main"
			set theVoice to title of its first menu item whose id is (get id of current menu item)
		end tell
		
	end if
end choose menu item

on action theObject
	if name of theObject is "speed" then
		set the_Speed to contents of slider "speed" of window "main" as integer
	end if
end action


on should quit after last window closed theObject
	return true
end should quit after last window closed


on checkOSversion()
	set fullOSdata to do shell script "/usr/bin/sw_vers"
	set OSVersion to word 2 of paragraph 2 of fullOSdata
end checkOSversion


(* Registers the settings (application preferences) with the 'user defaults'. *)
on registerSettings()
	tell user defaults
		-- Add all of the new default entries
		make new default entry at end of default entries with properties {name:"FirstRunFlag", contents:FirstRunFlag}
		make new default entry at end of default entries with properties {name:"theVoice", contents:theVoice}
		make new default entry at end of default entries with properties {name:"VoiceSpeed", contents:the_Speed}
		
		-- Now we need to register the new entries in the user defaults
		register
	end tell
end registerSettings


(* Reads the settings (application preferences) from the 'user defaults'. *)
on readSettings()
	tell user defaults
		set FirstRunFlag to contents of default entry "FirstRunFlag" as boolean
		set theVoice to contents of default entry "theVoice"
		set the_Speed to contents of default entry "VoiceSpeed"
		
	end tell
end readSettings


(* Writes the settings (application preferences) to the 'user defaults'. *)
on writeSettings()
	tell user defaults
		set contents of default entry "FirstRunFlag" to FirstRunFlag
		set contents of default entry "theVoice" to theVoice
		set contents of default entry "VoiceSpeed" to the_Speed
		
	end tell
end writeSettings

